var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import * as React from 'react';
import classNames from 'classnames';
import Icon from "../icon";
import "./style/button.css";
var prefixCls = 'dmc-btn';
export var Button = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _a, _b;

  var type = props.type,
      size = props.size,
      className = props.className,
      disabled = props.disabled,
      loading = props.loading,
      onlyLoading = props.onlyLoading,
      block = props.block,
      style = props.style,
      onClick = props.onClick,
      children = props.children,
      leftIcon = props.leftIcon,
      rightIcon = props.rightIcon,
      onlyIcon = props.onlyIcon,
      ghost = props.ghost,
      actived = props.actived,
      withoutBorder = props.withoutBorder,
      status = props.status,
      htmlType = props.htmlType,
      restProps = __rest(props, ["type", "size", "className", "disabled", "loading", "onlyLoading", "block", "style", "onClick", "children", "leftIcon", "rightIcon", "onlyIcon", "ghost", "actived", "withoutBorder", "status", "htmlType"]);

  var invalid = disabled || loading;
  var btnCls = classNames(prefixCls, (_a = {}, _a[prefixCls + "-" + type] = type, _a[prefixCls + "-danger"] = status === 'danger', _a[prefixCls + "-success"] = status === 'success', _a[prefixCls + "-" + size] = size, _a[prefixCls + "-ghost"] = ghost, _a[prefixCls + "-actived"] = actived, _a[prefixCls + "-disabled"] = invalid, _a[prefixCls + "-block"] = block, _a[prefixCls + "-without-border"] = withoutBorder, _a), className);
  var containerCls = classNames(prefixCls + "-container", (_b = {}, _b[prefixCls + "-container-loading"] = loading, _b));
  var node = loading ? onlyLoading ? _jsxs(React.Fragment, {
    children: [_jsx("span", __assign({
      className: prefixCls + "-context"
    }, {
      children: children
    }), void 0), _jsx("div", __assign({
      className: prefixCls + "-icon-wrapper"
    }, {
      children: _jsx(Icon, {
        icon: "loading",
        className: prefixCls + "-icon-loading"
      }, void 0)
    }), void 0)]
  }, void 0) : _jsxs(React.Fragment, {
    children: [_jsx(Icon, {
      icon: "loading",
      className: prefixCls + "-icon-loading"
    }, void 0), children]
  }, void 0) : onlyIcon ? _jsx(Icon, {
    icon: onlyIcon,
    className: prefixCls + "-only-icon"
  }, void 0) : _jsxs(React.Fragment, {
    children: [leftIcon && _jsx(Icon, {
      icon: leftIcon,
      className: prefixCls + "-left-icon"
    }, void 0), children, rightIcon && _jsx(Icon, {
      icon: rightIcon,
      className: prefixCls + "-right-icon"
    }, void 0)]
  }, void 0);
  return _jsxs("button", __assign({}, restProps, {
    type: htmlType,
    ref: ref,
    disabled: invalid,
    className: btnCls,
    onClick: invalid ? undefined : onClick,
    style: style
  }, {
    children: [_jsx("span", __assign({
      className: containerCls
    }, {
      children: node
    }), void 0), _jsx("span", {
      className: prefixCls + "-bg"
    }, void 0)]
  }), void 0);
});
Button.displayName = 'Button';
Button.defaultProps = {
  htmlType: 'button'
};
export default Button;
var ButtonMemo = /*#__PURE__*/React.memo(Button);
ButtonMemo.displayName = 'ButtonMemo';
export { ButtonMemo };

